/*A lekrdezsekhez hasznlt tblk:

NIKOVITS.DOLGOZO    (dkod, dnev, foglalkozas, fonoke, belepes, fizetes, jutalek, oazon)
NIKOVITS.OSZTALY    (oazon, onev, telephely)
NIKOVITS.CIKK       (ckod, cnev, szin, suly)
NIKOVITS.PROJEKT    (pkod, pnev, helyszin)
NIKOVITS.SZALLITO   (szkod, sznev, statusz, telephely)
NIKOVITS.SZALLIT    (szkod, ckod, pkod, mennyiseg, datum) 


Adjuk meg az albbi lekrdezst relcis algebrban kifejezve.
(Kiterjesztett illetve nem kiterjesztett relcis algebrban is)

Mely dolgoz(k)nak a legnagyobb a fizetse? (dkod)


Az albbi lekrdezseket adjuk meg SQL-ben.


Kivlaszts

- Kik azok a dolgozk, akiknek a fizetse > 2800?

- Kik azok a dolgozk, akik a 10-es vagy a 20-as osztlyon dolgoznak?

- Kik azok a dolgozk, akik 1982.01.01 utn lptek be a cghez?
-- Aktulis dtumformtumot lsd -> SYSDATE fv.

- Kik azok a dolgozk, akiknek a jutalka ismert? (vagyis nem NULL)


Direkt szorzat

- Kik azok a dolgozk, akiknek a fnke KING?

- Adjuk meg azokat a (nv, fnk) prokat, ahol a kt ember neve ugyanannyi betbl ll. 

- Kik azok a dolgozk, akik osztlynak telephelye DALLAS vagy CHICAGO?


Klnbsg

- Kik azok a dolgozk, akik osztlynak telephelye nem DALLAS s nem CHICAGO?


Vetts

- Adjuk meg a dolgozk kztt elfordul foglalkozsok neveit.


Uni

- Adjuk meg azoknak a nevt, akiknek a fizetse > 2000 vagy a CHICAGO-i osztlyon dolgoznak.


sszest (Aggregtor) fggvnyek

- Mekkora a minimlis/maximlis fizets a dolgozk kztt?

- Kinek a legkisebb/legnagyobb a fizetse?

- Mennyi a dolgozk sszfizetse?

- Mennyi a 20-as osztlyon az tlagfizets?

- Adjuk meg, hogy hny klnbz foglalkozs fordul el a dolgozk kztt. 


Csoportkpzs

- Adjuk meg osztlyonknt az tlagfizetst (OAZON, ATL_FIZ).

- Adjuk meg osztlyonknt a telephelyet s az tlagfizetst 
  (OAZON, TELEPHELY, ATL_FIZ).

- Adjuk meg, hogy az egyes osztlyokon hny ember dolgozik.


Csoportok szrse

- Adjuk meg azokra az osztlyokra az tlagfizetst, ahol ez nagyobb mint 2000.
- Adjuk meg az tlagfizetst azokon az osztlyokon, ahol legalbb 4-en dolgoznak (oazon, avg_fiz)
- Adjuk meg az tlagfizetst s telephelyet azokon az osztlyokon, ahol legalbb 4-en dolgoznak.
- Adjuk meg azon osztlyok nevt s telephelyt, ahol az tlagjvedelem (fizets+jutalek) nagyobb mint 2000. 
   (onev, telephely, tlagjv)
- Adjuk meg osztlyonknt a legkisebb fizetsu dolgozt, s fizetst (oazon, dnev, fizetes).

Beptett fggvnyek

- Adjuk meg azon dolgozkat, akik nevnek msodik betje 'A'.

- Adjuk meg azon dolgozkat, akik nevben van legalbb kt 'L' bet. 

- Adjuk meg a dolgozk fizetseinek ngyzetgykt s 3-mal vett maradkt. 

- Adjuk meg, hogy hny napja dolgozik a cgnl ADAMS s milyen hnapban lpett be.*/

/*1.6 plda (Kende Mria-Nagy Istvn: Oracle pldatr - SQL, PL/SQL. Panem kiad.)
Listzzuk ki a dolgozk nevt s fizetst, valamint jelentsk meg a fizetst grafikusan
gy, hogy a fizetst 1000 Ft-ra kerektve, minden 1000 Ft-ot egy '#' jel jell.*/
select dnev, fizetes, ltrim(rpad(' ',round(fizetes, -3)/1000+1,'#')) from dolgozo;

/*1.8 plda
Listzzuk ki azoknak a dolgozknak a nevt, fizetst, jutalkt, s a jutalk/fizets
arnyt, akiknek a foglalkozsa elad (salesman). Az arnyt kt tizedesen jelentsk meg.*/
select dnev, fizetes, jutalek, to_char(nvl(jutalek,0)/fizetes, '0.99') from dolgozo;

/*- Adjuk meg azon dolgozk nevt, fizetst, jutalkt, adsvjt s fizetend adjt, akik
  nevben van S-bet. Adsvok 1000 alatt 0%, 1000 s 2000 kztt 20%, 2000 s 3000 kztt
  30%, 3000 fltt 35%. Az adt a teljes jvedelemre (sal+comm) a megadott kulccsal kell fizetni.*/
select dnev, fizetes, jutalek, 
decode(trunc((fizetes+nvl(jutalek,0))/1000),0,0,1,0.2,2,0.3,0.35) adkulcs,
decode(trunc((fizetes+nvl(jutalek,0))/1000),0,0,1,0.2,2,0.3,0.35)*(fizetes+nvl(jutalek,0)) ad
from dolgozo;

select dnev, fizetes, jutalek, 
case trunc((fizetes+nvl(jutalek,0))/1000) when 0 then 0
                                          when 1 then 0.2
                                          when 2 then 0.3
                                          else 0.35
end * (fizetes+nvl(jutalek,0)) ad
from dolgozo;

/*2.17 feladat
Ksztsnk listt a pros s pratlan azonostj dolgozk szmrl.*/
select decode(mod(dkod, 2),0,'pros',1,'pratlan') as parits, count(*) as letszam from dolgozo
group by mod(dkod, 2);

/*2.23 feladat
Listzzuk ki munkakrnknt a dolgozk szmt, tlagfizetst (kerektve) numerikusan s grafikusan is.
200-anknt jelentsnk meg egy '#'-ot

3.7 feladat
Listzza ki minden rszleg legkisebb jvedelm (sal+comm) dolgozjnak nevt, fizetst, jutalkt.

3.8 feladat
Listzza ki azon rszlegek nevt s telephelyt, ahol az tlagjvedelem (sal+comm) kisebb mint 2200.


Alkrds (Subselect)  =ANY, <ALL, IN, EXISTS ...

- Adjuk meg azon cikkek kdjt s nevt, amelyeket valamelyik pcsi szllt szllt.

- Adjuk meg, hogy hny ilyen cikk van

- Adjuk meg azon cikkek kdjt s nevt, amelyeket egyik pcsi szllt sem szllt.*/
select ckod, cnev from cikk where ckod not in 
  (select ckod from szallit where szkod in
    (select szkod from szallito where telephely='Pecs')
  );

/*- Adjuk meg, hogy hny ilyen cikk van

- Adjuk meg azon szlltk nevt, akiknek a sttusza 10-nl nagyobb s 
  budapesti projektbe szlltanak szk nev cikket.

- Adjuk meg azon projektek kdjt, amelyekhez szlltanak kk cikket.*/
select pkod, pnev from projekt where pkod not in 
  (select distinct pkod from szallit where ckod in
   (select ckod from cikk where szin='zold')
   ); --res halmaz

/*- Adjuk meg azon projektek kdjt s nevt, amelyekhez szlltanak kk cikket.

- Adjuk meg azon projektek kdjt s nevt, amelyekhez nem szlltanak kk cikket.

- Adjuk meg azon cikkek kdjt, amelyeket szlltanak valahova.
  Adjuk meg, hogy hny ilyen cikk van.

- Adjuk meg azon cikkek kdjt, amelyeket nem szlltanak sehova.

- Adjuk meg azon cikkek kdjt s nevt, amelyeket sehova nem szlltanak.

- Adjuk meg azon kk cikkek kdjt, amelyeket szlltanak valahova.

- Adjuk meg azon piros szn cikkek kdjt, amelyeket sehova nem szlltanak.

- Adjuk meg azon cikkek nevt, amelyeket minden projekthez szlltanak.

- Melyik cikket hny klnbz projekthez szlltjk? (ckod, cnev, darab)*/
select cikk.ckod, cnev, count(distinct pkod) from szallit, cikk where szallit.ckod=cikk.ckod group by cikk.ckod, cnev order by 3 desc;

/*- Melyik cikket szlltjk a legtbb projekthez? 
  (Ha tbb ilyen cikk van, elg 1-et megadni kzlk -> ROWNUM segtsgvel)*/
select * from 
  (select dnev, fizetes from dolgozo order by fizetes)
  where rownum <=2;
  
select * from
  (select cikk.ckod, cnev, count(distinct pkod) from szallit, cikk where szallit.ckod=cikk.ckod group by cikk.ckod, cnev order by 3 desc)
  where rownum=1;

/*- Adjuk meg azon cikkek nevt, amelyeket valamelyik projekthez nem szlltanak.

- Adjuk meg azon cikkek kdjt s nevt, amelyeket kevesebb mint 6 projekthez szlltanak.

- Adjuk meg azon zld szn cikkek nevt, amelyeket minden projekthez szlltanak.

- Adjuk meg azon zld szn cikkek nevt, amelyet valamelyik projekthez nem szlltanak.

- Adjuk meg azon projektek nevt, amelyekhez minden zld szn cikket szlltanak.

- Adjuk meg azon szlltk nevt s telephelyt, akik valamelyik cikket 
  (nem felttlenl ugyanazt) minden projekthez szlltjk.

- Adjuk meg azon szlltk nevt s telephelyt, akik valamelyik cikket 
  (nem felttlenl ugyanazt) minden pcsi projekthez szlltjk.

- Adjuk meg azon szlltk nevt s telephelyt, akik valamelyik kk cikket 
  (nem felttlenl ugyanazt) minden projekthez szlltjk.

- Adjuk meg azon szlltk nevt, akik minden cikket szlltanak minden projekthez.

- Adjuk meg azon szlltk nevt, akik minden kek cikket szlltanak minden projekthez.
*/


--------------------- JOIN ---------------------

select dnev, telephely from dolgozo, osztaly where dolgozo.oazon=osztaly.oazon;

select dnev, telephely from dolgozo natural join osztaly;

select dnev, telephely from dolgozo join osztaly using (oazon);

select dnev, telephely from dolgozo d join osztaly o on (d.oazon=o.oazon);

